; Line drawing procedure by Pablo Reda.

;******************************************* 
linea:	; eax=x1 ebx=y1 ecx=x2 edx=y2


	cmp ebx,edx
	je horizontal 
	jg .noswap 
	xchg eax,ecx 
	xchg ebx,edx 
.noswap: 
	shl eax,16 
	shl ecx,16 
	sub eax,ecx 
	push ebx 
	push edx 
	sub ebx,edx 
	add ebx,1 
	cdq 
	idiv ebx 
	mov esi,eax 
	add ecx,$7fff 
	pop ebx 
	pop edx 
.lineas: 
	mov eax,ecx 
	add eax,esi 
	push ebx 
	push eax 
	shr ecx,16 
	shr eax,16 
	call horizontal 
	pop ecx 
	pop ebx 
	add ebx,1 
	cmp ebx,edx 
	jle .lineas
    ;	 mov esp,ebp
    ;	 ret 4
	ret

horizontal:  ; eax=x1 ebx=y1 ecx=x2 
	cmp ecx,eax 
	jg .m 
	xchg ecx,eax 
.m: 
	sub ecx,eax 
	jnz .nn
	add ecx,1 
.nn:
	imul ebx,[screen_width_var] ;edi
	add eax,ebx
    ;	 lea edi,[eax*4]
    ;	 add  edi,[line_buffer_var]  ; bit more universal
	mov edi,[lbuffer_ptr]
	lea edi,[edi+eax*4]
	push  eax

	mov eax,[line_color]  ;0x0000ff00

.l:
	mov dword [edi],eax
	add edi,4
	sub ecx,1
	jnz .l
	pop  eax
	ret 
